Ticket #7832

90°傾いた QR コードの読み取りのためのパッチ
Open Date: 2006-01-11 00:36 Last Update: 2006-04-19 14:04

Reporter:
Owner:
(None)
Type:
Status:
Closed
Component:
(None)
MileStone:
(None)
Priority:
5 - Medium
Severity:
5 - Medium
Resolution:
Fixed
File:
2

Details

まえだと申します.たいへん有用なソフトウェアの公開をありが
とうございます.
さて,既知のバグとして,90°傾いた QR コードが読み取れない
ことが挙げられていますが,添付のパッチのように型番情報の読
み取り部分を修正すると,読めるようになるようです.
(Windows 2000SP4, java version "1.5.0_06")
もちろん十分なテストをしたわけではありませんが,ご参考ま
で.

Ticket History (3/10 Histories)

2006-01-11 00:36 Updated by: marlowe
  • File 1402: qrcode.diff is attached
2006-01-11 04:40 Updated by: yanbe
Comment
Logged In: YES
user_id=11998

はじめまして、まえださん。
このプロジェクトの管理・運営をしている山家と申します。
パッチの提供、ありがとうございます。
しかもソースコードの見苦しい箇所に手を入れていただいて
恐縮です。

さて、修正箇所についてですが、パッチを適用した上で
実際に90度回転させたQRコード画像でいくつかチェック
してみたところ、バグが修正され、正しく動いているようです。

パッチ適用前は、デコード処理初期の型番情報などの
モジュールに対して、本来の位置から大きく外れた場所を
読み取ってしまうような現象がたまに発生していました。
しかしパッチ適用後はそのような現象は、今のところ
ありません。

今回のような座標変換処理の潜在的なバグを
baseLineX.translate(1,1);
といった形でアドホックにごまかしている箇所があるのが、
デコード性能が上がらない大きな原因だと考えているので、
今後はソースコードの汚い部分を修正しつつこのようなバグを
潰していきたいと思います。

あとは、計算過程で起こる端数切捨て誤差による位置ずれの
問題を解決できれば、もう一段階デコード性能を上げられ
そうです。
2006-01-11 04:40 Updated by: yanbe
Comment
Logged In: YES
user_id=11998

はじめまして、まえださん。
このプロジェクトの管理・運営をしている山家と申します。
パッチの提供、ありがとうございます。
しかもソースコードの見苦しい箇所に手を入れていただいて
恐縮です。

さて、修正箇所についてですが、パッチを適用した上で
実際に90度回転させたQRコード画像でいくつかチェック
してみたところ、バグが修正され、正しく動いているようです。

パッチ適用前は、デコード処理初期の型番情報などの
モジュールに対して、本来の位置から大きく外れた場所を
読み取ってしまうような現象がたまに発生していました。
しかしパッチ適用後はそのような現象は、今のところ
ありません。

今回のような座標変換処理の潜在的なバグを
baseLineX.translate(1,1);
といった形でアドホックにごまかしている箇所があるのが、
デコード性能が上がらない大きな原因だと考えているので、
今後はソースコードの汚い部分を修正しつつこのようなバグを
潰していきたいと思います。

あとは、計算過程で起こる端数切捨て誤差による位置ずれの
問題を解決できれば、もう一段階デコード性能を上げられ
そうです。
2006-01-11 04:40 Updated by: yanbe
Comment
Logged In: YES
user_id=11998

はじめまして、まえださん。
このプロジェクトの管理・運営をしている山家と申します。
パッチの提供、ありがとうございます。
しかもソースコードの見苦しい箇所に手を入れていただいて
恐縮です。

さて、修正箇所についてですが、パッチを適用した上で
実際に90度回転させたQRコード画像でいくつかチェック
してみたところ、バグが修正され、正しく動いているようです。

パッチ適用前は、デコード処理初期の型番情報などの
モジュールに対して、本来の位置から大きく外れた場所を
読み取ってしまうような現象がたまに発生していました。
しかしパッチ適用後はそのような現象は、今のところ
ありません。

今回のような座標変換処理の潜在的なバグを
baseLineX.translate(1,1);
といった形でアドホックにごまかしている箇所があるのが、
デコード性能が上がらない大きな原因だと考えているので、
今後はソースコードの汚い部分を修正しつつこのようなバグを
潰していきたいと思います。

あとは、計算過程で起こる端数切捨て誤差による位置ずれの
問題を解決できれば、もう一段階デコード性能を上げられ
そうです。
2006-01-11 23:55 Updated by: marlowe
Comment
Logged In: YES
user_id=17315

まえだです.丁重なコメントを頂き恐縮です.
また,早速パッチを試して下さったようで,ありがとうございます.
今後も完成度が上がっていきそうですので,たいへん楽しみにしており
ます.
2006-02-13 00:09 Updated by: marlowe
Comment
Logged In: YES
user_id=17315

以前投稿したパッチは,1個目の型番情報の読み取り部分だけしか修正
しておりませんでしたので,(1個目の読み取りが失敗したときの)2個
目の読み取り部も修正したパッチを改めて添付いたします.
2006-02-13 00:09 Updated by: marlowe
  • File 1453: qrcode2.diff is attached
2006-04-19 13:40 Updated by: yanbe
Comment
Logged In: YES
user_id=11998

報告が遅くなりましてすみません。

先ほど、まえださんに添付して頂いたパッチを無事適用し、CVSに
反映することができました。傾いたQRコードにおけるモジュールの
サンプリング精度が上がったのが確認できました。

これで、大きな懸案事項が解決したので助かりました。
ありがとうございました。
2006-04-19 14:04 Updated by: yanbe
  • Resolution Update from None to Fixed
2006-04-19 14:04 Updated by: yanbe
  • Status Update from Open to Closed
  • Ticket Close date is changed to 2006-04-19 14:04

Attachment File List

Edit

You are not logged in. I you are not logged in, your comment will be treated as an anonymous post. » Login